GeoTessCPP: geotess::GeoTessProfileSurface Class Reference

GeoTessCPP 2.2.3 Software to facilitate storage and retrieval of 3D information about the Earth.

Public Member Functions | Static Public Member Functions | List of all members
geotess::GeoTessProfileSurface Class Reference

A Profile object that defines a single Data object and no radius value. More...

`#include <GeoTessProfileSurface.h>`

Inheritance diagram for geotess::GeoTessProfileSurface:

## Public Member Functions
| GeoTessProfileSurface (GeoTessData *dat)
virtual int | class_size () const
virtual LONG_INT | getMemory ()
virtual const GeoTessProfileType & | getType () const
virtual bool | operator== (const GeoTessProfile &p) const
virtual double | getValue (int attributeIndex, int nodeIndex) const
virtual double | getValueTop (int attributeIndex) const
virtual bool | isNaN (int nodeIndex, int attributeIndex)
virtual double | getValue (const GeoTessInterpolatorType &rInterpType, int attributeIndex, double radius, bool allowRadiusOutOfRange) const
virtual float | getRadius (int i) const
virtual int | getNRadii () const
virtual int | getNData () const
virtual float * | getRadii ()
virtual GeoTessData ** | getData ()
virtual GeoTessData * | getData (int i)
virtual const GeoTessData & | getData (int i) const
virtual void | setData (const vector< GeoTessData * > &inData)
virtual void | setData (int index, GeoTessData *inData)
virtual void | setRadii (const vector< float > &newRadii)
virtual void | setRadius (int index, float radius)
virtual float | getRadiusTop () const
virtual const GeoTessData & | getDataTop () const
virtual GeoTessData * | getDataTop ()
virtual float | getRadiusBottom () const
virtual const GeoTessData & | getDataBottom () const
virtual GeoTessData * | getDataBottom ()
Public Member Functions inherited from geotess::GeoTessProfile
double | getValue (const vector< int > &nodeIds, const vector< double > &coefficients, int attributeIndex) const
virtual double | getValueBottom (int attributeIndex) const
double | getThickness ()
int | getRadiusIndex (double radius) const
virtual int | getRadiusIndex (double radius, int jlo) const
virtual double | getInterpolationCoefficient (int i, double radius, bool allowOutOfRange) const
virtual int | getPointIndex (int nodeIndex) const
virtual int | findClosestRadiusIndex (double radius) const

## Static Public Member Functions
static string | class_name ()
Static Public Member Functions inherited from geotess::GeoTessProfile
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< GeoTessData * > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< double > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< float > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< LONG_INT > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< int > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< short > > &data)
static GeoTessProfile * | newProfile (const vector< float > &radii, vector< vector< byte > > &data)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, GeoTessData **data, const int &nData)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, double **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, float **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, LONG_INT **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, int **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, short **values, const int &nNodes, const int &nAttributes)
static GeoTessProfile * | newProfile (float *radii, const int &nRadii, byte **values, const int &nNodes, const int &nAttributes)
static string | class_name ()
static int | class_count ()

## Detailed Description

A Profile object that defines a single Data object and no radius value.

A Profile object used to support 2D models. It represents a single Data object and no radius value. ProfileSurface objects are incompatible with all other Profile types in the sense that a model that contains any ProfileSurface objects must be made up entirely of ProfileSurface objects.

Definition at line 78 of file GeoTessProfileSurface.h.

## Constructor & Destructor Documentation

## ◆ GeoTessProfileSurface()

geotess::GeoTessProfileSurface::GeoTessProfileSurface | ( | GeoTessData * | dat | ) |
| inline

Default constructor.

Definition at line 103 of file GeoTessProfileSurface.h.

## Member Function Documentation

## ◆ class_name()

static string geotess::GeoTessProfileSurface::class_name | ( |  | ) |
| inlinestatic

Returns the class name.

Definition at line 109 of file GeoTessProfileSurface.h.

## ◆ class_size()

virtual int geotess::GeoTessProfileSurface::class_size | ( |  | ) | const
| inlinevirtual

Returns the class size.

Reimplemented from geotess::GeoTessProfile.

Definition at line 114 of file GeoTessProfileSurface.h.

## ◆ getData() [1/3]

virtual GeoTessData** geotess::GeoTessProfileSurface::getData | ( |  | ) |
| inlinevirtual

Retrieve a shallow copy of all of the Data objects associated with thisProfile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 209 of file GeoTessProfileSurface.h.

## ◆ getData() [2/3]

virtual GeoTessData* geotess::GeoTessProfileSurface::getData | ( | int | i | ) |
| inlinevirtual

Retrieve a reference the i'th Data object

Reimplemented from geotess::GeoTessProfile.

Definition at line 215 of file GeoTessProfileSurface.h.

## ◆ getData() [3/3]

virtual const GeoTessData& geotess::GeoTessProfileSurface::getData | ( | int | i | ) | const
| inlinevirtual

Retrieve a reference the i'th Data object

Reimplemented from geotess::GeoTessProfile.

Definition at line 220 of file GeoTessProfileSurface.h.

## ◆ getDataBottom() [1/2]

virtual GeoTessData* geotess::GeoTessProfileSurface::getDataBottom | ( |  | ) |
| inlinevirtual

Get the Data object at the bottom of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 274 of file GeoTessProfileSurface.h.

## ◆ getDataBottom() [2/2]

virtual const GeoTessData& geotess::GeoTessProfileSurface::getDataBottom | ( |  | ) | const
| inlinevirtual

Get the Data object at the bottom of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 269 of file GeoTessProfileSurface.h.

## ◆ getDataTop() [1/2]

virtual GeoTessData* geotess::GeoTessProfileSurface::getDataTop | ( |  | ) |
| inlinevirtual

Get the Data object at the top of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 258 of file GeoTessProfileSurface.h.

## ◆ getDataTop() [2/2]

virtual const GeoTessData& geotess::GeoTessProfileSurface::getDataTop | ( |  | ) | const
| inlinevirtual

Get the Data object at the top of the profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 253 of file GeoTessProfileSurface.h.

## ◆ getMemory()

virtual LONG_INT geotess::GeoTessProfileSurface::getMemory | ( |  | ) |
| inlinevirtual

Reimplemented from geotess::GeoTessProfile.

Definition at line 117 of file GeoTessProfileSurface.h.

## ◆ getNData()

virtual int geotess::GeoTessProfileSurface::getNData | ( |  | ) | const
| inlinevirtual

Get the number of Data objects that comprise this profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 199 of file GeoTessProfileSurface.h.

## ◆ getNRadii()

virtual int geotess::GeoTessProfileSurface::getNRadii | ( |  | ) | const
| inlinevirtual

Get the number of radii that comprise this profile.

Reimplemented from geotess::GeoTessProfile.

Definition at line 194 of file GeoTessProfileSurface.h.

## ◆ getRadii()

virtual float* geotess::GeoTessProfileSurface::getRadii | ( |  | ) |
| inlinevirtual

Returns NULL

Reimplemented from geotess::GeoTessProfile.

Definition at line 204 of file GeoTessProfileSurface.h.

## ◆ getRadius()

virtual float geotess::GeoTessProfileSurface::getRadius | ( | int | i | ) | const
| inlinevirtual

Get the i'th radius value in this profile in km. Radii are in order of increasing radius.

Reimplemented from geotess::GeoTessProfile.

Definition at line 188 of file GeoTessProfileSurface.h.

## ◆ getRadiusBottom()

virtual float geotess::GeoTessProfileSurface::getRadiusBottom | ( |  | ) | const
| inlinevirtual

Get the radius at the bottom of the profile, in km.

Reimplemented from geotess::GeoTessProfile.

Definition at line 263 of file GeoTessProfileSurface.h.

## ◆ getRadiusTop()

virtual float geotess::GeoTessProfileSurface::getRadiusTop | ( |  | ) | const
| inlinevirtual

Get the radius at the top of the profile, in km.

Reimplemented from geotess::GeoTessProfile.

Definition at line 247 of file GeoTessProfileSurface.h.

## ◆ getType()

virtual const GeoTessProfileType& geotess::GeoTessProfileSurface::getType | ( |  | ) | const
| inlinevirtual

Returns ProfileType (SURFACE).

Returns
  ProfileType (SURFACE).

Reimplemented from geotess::GeoTessProfile.

Definition at line 125 of file GeoTessProfileSurface.h.

## ◆ getValue() [1/2]

virtual double geotess::GeoTessProfileSurface::getValue | ( | const GeoTessInterpolatorType & | rInterpType,
|  | int | attributeIndex,
|  | double | radius,
|  | bool | allowRadiusOutOfRange
| ) |  | const
| inlinevirtual

Retrieve the value of the specified attribute interpolated at the specified radius. Ignore allowRadiusOutOfRange.

Reimplemented from geotess::GeoTessProfile.

Definition at line 177 of file GeoTessProfileSurface.h.

## ◆ getValue() [2/2]

virtual double geotess::GeoTessProfileSurface::getValue | ( | int | attributeIndex,
|  | int | nodeIndex
| ) |  | const
| inlinevirtual

Retrieve the value of the specified attribute from this profile at the specified node index

Parameters

  attributeIndex |
  nodeIndex |

Returns
  double

Reimplemented from geotess::GeoTessProfile.

Definition at line 144 of file GeoTessProfileSurface.h.

## ◆ getValueTop()

virtual double geotess::GeoTessProfileSurface::getValueTop | ( | int | attributeIndex | ) | const
| inlinevirtual

Retrieve the value of the specified attribute at the top of the layer.

Parameters

  attributeIndex |

Returns
  double

Reimplemented from geotess::GeoTessProfile.

Definition at line 155 of file GeoTessProfileSurface.h.

## ◆ isNaN()

virtual bool geotess::GeoTessProfileSurface::isNaN | ( | int | nodeIndex,
|  | int | attributeIndex
| ) |  |
| inlinevirtual

Return true if the specified Data value is NaN. For doubles and floats, this means not NaN. For bytes, shorts, ints and longs, always returns false since there is no value that is NaN.

Parameters

  nodeIndex |
  attributeIndex |

Returns
  true if the specified Data value is NaN.

Reimplemented from geotess::GeoTessProfile.

Definition at line 168 of file GeoTessProfileSurface.h.

## ◆ operator==()

virtual bool geotess::GeoTessProfileSurface::operator== | ( | const GeoTessProfile & | p | ) | const
| inlinevirtual

Return true if the input Profile object (p) equals this Profile object.

Reimplemented from geotess::GeoTessProfile.

Definition at line 131 of file GeoTessProfileSurface.h.

## ◆ setData() [1/2]

virtual void geotess::GeoTessProfileSurface::setData | ( | const vector< GeoTessData * > & | inData | ) |
| inlinevirtual

Resets the data object to the new input data

Reimplemented from geotess::GeoTessProfile.

Definition at line 225 of file GeoTessProfileSurface.h.

## ◆ setData() [2/2]

virtual void geotess::GeoTessProfileSurface::setData | ( | int | index,
|  | GeoTessData * | inData
| ) |  |
| inlinevirtual

Resets the data object at index to the new input data.

Reimplemented from geotess::GeoTessProfile.

Definition at line 231 of file GeoTessProfileSurface.h.

## ◆ setRadii()

virtual void geotess::GeoTessProfileSurface::setRadii | ( | const vector< float > & | newRadii | ) |
| inlinevirtual

Replace the radii currently associated with this Profile with new values.

Reimplemented from geotess::GeoTessProfile.

Definition at line 238 of file GeoTessProfileSurface.h.

## ◆ setRadius()

virtual void geotess::GeoTessProfileSurface::setRadius | ( | int | index,
|  | float | radius
| ) |  |
| inlinevirtual

Replace the radius at the specified nodeIndex.

Reimplemented from geotess::GeoTessProfile.

Definition at line 241 of file GeoTessProfileSurface.h.

The documentation for this class was generated from the following file:

- rstt/GeoTessCPP/include/GeoTessProfileSurface.h